#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES7-10
class Ues::Core::Artifact::UESMetaArtifact
  private_class_method :new

  BEMAR_CODE = Java::cz.ues.core.artifact.UESMetaArtifact::BEMAR_CODE #:nodoc:


# This command returns attributes representing the meta artifact specified by the metaArtifactUri parameter. Only basic meta artifact
# types attributes can be returned by this command (no meta role, meta group, etc.). The command does not change the state of the meta
# artifact in the system.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of a meta artifact whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the meta artifact attributes
# 
# <tt><b>throws</b></tt> UESMetaArtifactRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(metaArtifactUri)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.getAttributes(metaArtifactUri)
    if (_r != nil) then _r = Ues::Core::Artifact::UESMetaArtifactAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESMetaArtifact
    alias attributes getAttributes
  end

# Command for setting attributes of a meta artifact. The command can't modify references to objects like location, competent role and so
# on.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of a meta artifact whose attributes are returned
# 
# <tt><b>param</b></tt> metaArtifact DTO containing new attributes of the meta artifact
# 
# <tt><b>return</b></tt> UESURI of the meta artifact
# 
# <tt><b>throws</b></tt> UESMetaArtifactRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(metaArtifactUri, metaArtifact = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    metaArtifact = Ues::Core::Artifact::UESMetaArtifactSetAttributes.new(metaArtifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.setAttributes(metaArtifactUri, metaArtifact)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESMetaArtifact
    alias set_attributes setAttributes
  end

# Copy a meta artifact. The command creates a new meta artifact according to specified source meta artifact in a specified location in
# the same territory as source meta artifact. At the very least location and name must be specified in UESMetaArtifactCopy DTO.
# Only basic meta artifact types can be copied by this command (no meta role, meta group, etc.). Competent role for the new meta artifact
# copy will be selected as the most suitable according to specified container and meta artifact (executive/authorized role with connected
# interface), or can be also specified in UESMetaArtifactCopy DTO.
# 
# <tt><b>param</b></tt> sourceMetaArtifactUri UESURI of the meta artifact which will be copied.
# 
# <tt><b>param</b></tt> metaArtifact DTO containing attributes of the new meta artifact copy.
# 
# <tt><b>return</b></tt> UESURI of the copied meta artifact.
# 
# <tt><b>throws</b></tt> UESMetaArtifactRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.copy(sourceMetaArtifactUri, metaArtifact = nil)
    sourceMetaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(sourceMetaArtifactUri).to_java
    metaArtifact = Ues::Core::Artifact::UESMetaArtifactCopy.new(metaArtifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.copy(sourceMetaArtifactUri, metaArtifact)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command exports a meta artifact to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is
# why it returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the meta artifact to export
# 
# <tt><b>param</b></tt> metaArtifact DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> UESMetaArtifactRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.export(metaArtifactUri, metaArtifact = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    metaArtifact = Ues::Core::Artifact::UESMetaArtifactExport.new(metaArtifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.export(metaArtifactUri, metaArtifact)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Creates a meta artifact from an exported XML file in the specified location.
# Source meta artifact must be derived (at least indirectly) from a meta artifact which is a part of UU.OS uuApp.
# Creation of meta artifact is divided into synchronous and asynchronous part. During the synchronous part,
# the meta artifact is created. During the asynchronous part, the template objects are created.
# If the asynchronous process fails and the Problem state is set on meta artifact, it is possible to solve the problem (e.g. add reference_map)
# and run the command again.
# 
# <tt><b>param</b></tt> locationUri UESURI of the Meta Model Dictionary where new Meta Artifact is created.
# 
# <tt><b>param</b></tt> metaArtifact DTO that contains attributes of the new Meta Artifact.
# 
# <tt><b>return</b></tt> UESURI of the new Meta Artifact.
# 
# <tt><b>throws</b></tt> UESMetaArtifactRTException
# 
# <tt><b>deprecated</b></tt> This command is backward incompatible (older versions of the meta artifact's XML can be unsupported). New commands will be
# prepared for creating object templates.
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(locationUri, metaArtifact = nil)
    warn "[DEPRECATED: Ues::Core::Artifact::UESMetaArtifact.create] This command is backward incompatible (older versions of the meta artifact's XML can be unsupported). New commands will be
            prepared for creating object templates."
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    metaArtifact = Ues::Core::Artifact::UESMetaArtifactCreate.new(metaArtifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.create(locationUri, metaArtifact)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported meta artifact.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of the meta artifact we want to get the exported file from.
# 
# <tt><b>param</b></tt> metaArtifact DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported meta artifact.
# 
# <tt><b>throws</b></tt> UESMetaArtifactRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getExportData(metaArtifactUri, metaArtifact = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    metaArtifact = Ues::Core::Artifact::UESMetaArtifactGetExportData.new(metaArtifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.getExportData(metaArtifactUri, metaArtifact)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESMetaArtifact
    alias export_data getExportData
  end

# Configures an artifact presentation template. Artifact presentation template consist of width, header visibility, toolbar visibility,
# and context menu visibility. All of these attributes control default presentation of an artifact created with this meta artifact. When
# viewing an artifact, presentation settings are looked up in the following order: User settings, artifact presentation settings, meta
# artifact template presentation settings, and layout artifact, if it is configured, or default system settings otherwise. Attribute
# lockSettings on the DTO can make user settings and artifact presentation settings to be ignored.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of the meta artifact whose presentation template is to be changed.
# 
# <tt><b>param</b></tt> presentation DTO containing presentation template values.
# 
# <tt><b>throws</b></tt> cz.ues.core.artifact.exception.UESMetaArtifactRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.setDefaultPresentationAttributes(metaArtifactUri, presentation = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    presentation = Ues::Core::Artifact::UESMetaArtifactSetDefaultPresentationAttributes.new(presentation).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.setDefaultPresentationAttributes(metaArtifactUri, presentation)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESMetaArtifact
    alias set_default_presentation_attributes setDefaultPresentationAttributes
  end

# Retrieves an artifact presentation template. Artifact presentation template consists of width, header visibility, toolbar visibility,
# and context menu visibility. All of these attributes control default presentation of an artifact created with this meta artifact. When
# viewing an artifact, presentation settings are looked up in the following order: User settings, artifact presentation settings, meta
# artifact template presentation settings, and layout artifact, if it is configured, or default system settings otherwise. Attribute
# lockSettings on the DTO can make user settings and artifact presentation settings to be ignored.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of the meta artifact whose presentation template is to be retrieved.
# 
# <tt><b>throws</b></tt> cz.ues.core.artifact.exception.UESMetaArtifactRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getDefaultPresentationAttributes(metaArtifactUri)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.getDefaultPresentationAttributes(metaArtifactUri)
    if (_r != nil) then _r = Ues::Core::Artifact::UESMetaArtifactDefaultPresentationAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESMetaArtifact
    alias default_presentation_attributes getDefaultPresentationAttributes
  end

# Configures meta artifact presentation settings. Meta artifact presentation settings consist of width, layout artifact UESURI, header
# visibility, toolbar visibility, and context menu visibility. All of these attributes control presentation of the meta artifact. When
# viewing a meta artifact, presentation settings are looked up in the following order: User settings, meta artifact presentation
# settings, meta artifact template presentation settings, and layout artifact, if it is configured, or default system settings otherwise.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of the meta artifact whose presentation settings are to be changed.
# 
# <tt><b>param</b></tt> presentation DTO containing presentation settings.
# 
# <tt><b>throws</b></tt> UESMetaArtifactRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.setPresentationAttributes(metaArtifactUri, presentation = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    presentation = Ues::Core::Artifact::UESMetaArtifactSetPresentationAttributes.new(presentation).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.setPresentationAttributes(metaArtifactUri, presentation)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESMetaArtifact
    alias set_presentation_attributes setPresentationAttributes
  end

# Retrieves meta artifact presentation settings. Meta artifact presentation settings consist of width, layout artifact UESURI, header
# visibility, toolbar visibility, and context menu visibility. All of these attributes control presentation of the meta artifact. When
# viewing a meta artifact, presentation settings are looked up in the following order: User settings, meta artifact presentation
# settings, meta artifact template presentation settings, and layout artifact, if it is configured, or default system settings otherwise.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of the meta artifact whose presentation settings are to be retrieved.
# 
# <tt><b>throws</b></tt> UESMetaArtifactRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getPresentationAttributes(metaArtifactUri)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESMetaArtifact.java_class)
    _r = _s.getPresentationAttributes(metaArtifactUri)
    if (_r != nil) then _r = Ues::Core::Artifact::UESMetaArtifactPresentationAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESMetaArtifact
    alias presentation_attributes getPresentationAttributes
  end
end
