#--
# This code is automatically generated, do not modify the content !!!
#++
# Sheet template service.
# 
# <tt><b>since</b></tt> UES8-03
# 
# <tt><b>author</b></tt> 10-7715-1
class Ues::Core::Content::UESSheetTemplate
  private_class_method :new


# Creates a new sheet template on the specified Meta Artifact. Initial sheet template content can be specified.
# 
# <tt><b>param</b></tt> marUri UESURI of the Meta Artifact where the new sheet template is created
# 
# <tt><b>param</b></tt> sheetTemplate Object containing attributes of the sheet template
# 
# <tt><b>return</b></tt> UESURI of the created sheet template
# 
# <tt><b>throws</b></tt> UESSheetTemplateRTException
# 
# <tt><b>throws</b></tt> UESSheetRTException
  def self.create(marUri, sheetTemplate = nil)
    marUri = Ues::Core::Commons::Uri::UESURI.new(marUri).to_java
    sheetTemplate = Ues::Core::Content::UESSheetTemplateCreate.new(sheetTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheetTemplate.java_class)
    _r = _s.create(marUri, sheetTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns attributes representing specified sheet template.
# 
# <tt><b>param</b></tt> sheetTemplateUri UESURI of a sheet template which attributes will be retrieved
# 
# <tt><b>return</b></tt> UESSheetTemplateAttributes Object containing the sheet template attributes
# 
# <tt><b>throws</b></tt> UESSheetTemplateRTException
  def self.getAttributes(sheetTemplateUri)
    sheetTemplateUri = Ues::Core::Commons::Uri::UESURI.new(sheetTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheetTemplate.java_class)
    _r = _s.getAttributes(sheetTemplateUri)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetTemplateAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheetTemplate
    alias attributes getAttributes
  end

# Returns the content of the sheet template. The content may be returned as structured UXML or full content including images in a
# compressed UDF format. The type of the returned stream is determined by options (see UESSheetTemplateGetData#requestedMimeType),
# UXML is returned by default.
# 
# <tt><b>param</b></tt> sheetTemplateUri UESURI of the sheet template, which content is being retrieved
# 
# <tt><b>param</b></tt> options Object containing options for content retrieving
# 
# <tt><b>return</b></tt> UESSheetStreamHandler with the sheet template data
# 
# <tt><b>throws</b></tt> UESSheetTemplateRTException
# 
# <tt><b>throws</b></tt> UESSheetRTException
  def self.getData(sheetTemplateUri, options = nil)
    sheetTemplateUri = Ues::Core::Commons::Uri::UESURI.new(sheetTemplateUri).to_java
    options = Ues::Core::Content::UESSheetTemplateGetData.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheetTemplate.java_class)
    _r = _s.getData(sheetTemplateUri, options)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheetTemplate
    alias data getData
  end

# Returns a list of sheet templates on the specified Meta Artifact. Command does not return all sheet templates, only a sublist. The list
# of returned sheet templates could be filtered by the name, code, main, visible, order of a sheet template, state of the lock and width.
# The list is sorted by the name (and code in case are equal) of a sheet template by default, or it can be sorted arbitrarily by any of
# sheet template attributes usable for the filtering or these attributes combinations. See the UES query documentation for more
# information.
# 
# <tt><b>param</b></tt> marUri UESURI of the Meta Artifact from where sheet templates are listed.
# 
# <tt><b>param</b></tt> criteria Object containing criteria for listing sheet templates.
# 
# <tt><b>return</b></tt> List of Object representing sheet templates. The same object as in the command getAttributes.
# 
# <tt><b>throws</b></tt> UESSheetTemplateRTException
  def self.getSheetTemplateList(marUri, criteria = nil)
    marUri = Ues::Core::Commons::Uri::UESURI.new(marUri).to_java
    criteria = Ues::Core::Content::UESSheetTemplateGetSheetTemplateList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheetTemplate.java_class)
    _r = _s.getSheetTemplateList(marUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheetTemplate
    alias sheet_template_list getSheetTemplateList
  end

# Updates basic attributes of the sheet template.
# 
# <tt><b>param</b></tt> sheetTemplateUri UESURI of the sheet template which attributes are to be changed
# 
# <tt><b>param</b></tt> sheetTemplate Object containing the sheet template attributes
# 
# <tt><b>return</b></tt> UESURI of the changed sheet template
# 
# <tt><b>throws</b></tt> UESSheetTemplateRTException
  def self.setAttributes(sheetTemplateUri, sheetTemplate = nil)
    sheetTemplateUri = Ues::Core::Commons::Uri::UESURI.new(sheetTemplateUri).to_java
    sheetTemplate = Ues::Core::Content::UESSheetTemplateSetAttributes.new(sheetTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheetTemplate.java_class)
    _r = _s.setAttributes(sheetTemplateUri, sheetTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheetTemplate
    alias set_attributes setAttributes
  end

# Replaces the content of the specified sheet template and unlock it by default. Sheet template content must be in UXML or UDF format.
# Sheet template must be locked by the current user or must be unlocked.
# 
# <tt><b>param</b></tt> sheetTemplateUri UESURI of the sheet template which content is to be replaced
# 
# <tt><b>param</b></tt> sheetTemplate Object containing attributes of the sheet template
# 
# <tt><b>throws</b></tt> UESSheetTemplateRTException
# 
# <tt><b>throws</b></tt> UESSheetRTException
  def self.checkIn(sheetTemplateUri, sheetTemplate = nil)
    sheetTemplateUri = Ues::Core::Commons::Uri::UESURI.new(sheetTemplateUri).to_java
    sheetTemplate = Ues::Core::Content::UESSheetTemplateCheckIn.new(sheetTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheetTemplate.java_class)
    _r = _s.checkIn(sheetTemplateUri, sheetTemplate)
    
    return _r
  end
  class << Ues::Core::Content::UESSheetTemplate
    alias check_in checkIn
  end

# Deletes the sheet template from the system. The sheet template is deleted even if it is locked. If the sheet temp,late is main, the
# next sheet template will be set as main.
# 
# <tt><b>param</b></tt> sheetTemplateUri UESURI of the sheet template which is about to be deleted
# 
# <tt><b>throws</b></tt> UESSheetTemplateRTException
  def self.delete(sheetTemplateUri)
    sheetTemplateUri = Ues::Core::Commons::Uri::UESURI.new(sheetTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheetTemplate.java_class)
    _r = _s.delete(sheetTemplateUri)
    
    return _r
  end
end
