#--
# This code is automatically generated, do not modify the content !!!
#++
# UES Property Template service.
# 
# <tt><b>author</b></tt> 10-7715-1
# 
# <tt><b>since</b></tt> UES8-03
class Ues::Core::Property::UESPropertyTemplate
  private_class_method :new


# Creates a new property template on the specified Meta Artifact or in the specified property template group. At the very least property
# template type and name have to be specified in this command. Value of the property template is optional.
# 
# <tt><b>param</b></tt> parentNodeUri UESURI of the Meta Artifact or of the property template group where the new property template is created
# 
# <tt><b>param</b></tt> propertyTemplate Object containing attributes of the new property template
# 
# <tt><b>return</b></tt> UESURI of the new property template
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.create(parentNodeUri, propertyTemplate = nil)
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    propertyTemplate = Ues::Core::Property::UESPropertyTemplateCreate.new(propertyTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.create(parentNodeUri, propertyTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Creates a new property template collection on the specified Meta Artifact or in the specified property collection template. At the very
# least property template collection name has to be specified in this command.
# 
# <tt><b>param</b></tt> parentNodeUri UESURI of the Meta Artifact or of the property collection template where the new property collection template is
# created
# 
# <tt><b>param</b></tt> propertyTemplateColl Object containing attributes of a new property collection template
# 
# <tt><b>return</b></tt> UESURI of the new property collection template
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.createCollection(parentNodeUri, propertyCollTemplate = nil)
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    propertyCollTemplate = Ues::Core::Property::UESPropertyTemplateCollectionCreate.new(propertyCollTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.createCollection(parentNodeUri, propertyCollTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias create_collection createCollection
  end

# Returns attributes representing the specified property template.
# 
# <tt><b>param</b></tt> propertyTemplateUri UESURI of the property template
# 
# <tt><b>return</b></tt> UESPropertyTemplateAttributes Object with property template attributes
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.getAttributes(propertyTemplateUri)
    propertyTemplateUri = Ues::Core::Commons::Uri::UESURI.new(propertyTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.getAttributes(propertyTemplateUri)
    if (_r != nil) then _r = Ues::Core::Property::UESPropertyTemplateAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias attributes getAttributes
  end

# Returns the value of the given property template of the corresponding type. Null in case the value is not set.
# 
# <tt><b>param</b></tt> propertyTemplateUri UESURI of the property template
# 
# <tt><b>return</b></tt> <T> T the value of the property template
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.getValue(propertyTemplateUri)
    propertyTemplateUri = Ues::Core::Commons::Uri::UESURI.new(propertyTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.getValue(propertyTemplateUri)
    _r = Ues::Core::Property::UESPropertyTemplate.send("convert_to_ruby", _r)
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias value getValue
  end

# Returns attributes of the specified property collection template.
# 
# <tt><b>param</b></tt> collectionTemplateUri UESURI of the property collection template, which attributes are to be retrieved.
# 
# <tt><b>return</b></tt> UESPropertyCollectionTemplateAttributes Object with attributes of the property collection template.
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.getCollectionAttributes(collectionTemplateUri)
    collectionTemplateUri = Ues::Core::Commons::Uri::UESURI.new(collectionTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.getCollectionAttributes(collectionTemplateUri)
    if (_r != nil) then _r = Ues::Core::Property::UESPropertyTemplateCollectionAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias collection_attributes getCollectionAttributes
  end

# Returns a list of entries (property templates or property template collections) enlisted in the specified property template collection
# or on the specified Meta Artifact (property template entries from the Meta Artifact root property template collection are returned in
# that case). Command does not return all entries, only a sublist. The list of returned entries could be filtered by the name, code or
# type of an entry. The list is sorted by the name (and code in case are equal) of an entry by default, or it can be sorted arbitrarily
# by any of entry attributes usable for the filtering or these attributes combinations. See the UES query documentation for more
# information.
# 
# <tt><b>param</b></tt> parentNodeUri UESURI of the Meta Artifact or of the property template collection from where entries (property templates or
# property template collections) are listed.
# 
# <tt><b>param</b></tt> criteria Object containing criteria for listing property template entries.
# 
# <tt><b>return</b></tt> List List of Object representing property template entries (property template or property template collections)
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.getEntryList(parentNodeUri, criteria = nil)
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    criteria = Ues::Core::Property::UESPropertyTemplateGetEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.getEntryList(parentNodeUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias entry_list getEntryList
  end

# Sets basic attributes of the specified property template.
# 
# <tt><b>param</b></tt> propertyTemplateUri UESURI of the property template
# 
# <tt><b>param</b></tt> propertyTemplate Object of the new attributes for the property template
# 
# <tt><b>return</b></tt> UESURI of the property template with new attributes
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.setAttributes(propertyTemplateUri, propertyTemplate = nil)
    propertyTemplateUri = Ues::Core::Commons::Uri::UESURI.new(propertyTemplateUri).to_java
    propertyTemplate = Ues::Core::Property::UESPropertyTemplateSetAttributes.new(propertyTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.setAttributes(propertyTemplateUri, propertyTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias set_attributes setAttributes
  end

# Modifies basic attributes of the property collection template specified in collTemplateUri.
# 
# <tt><b>param</b></tt> collTemplateUri UESURI of the property collection template which attributes is modified
# 
# <tt><b>param</b></tt> propertyCollTemplate Object containing attributes of the property collection template
# 
# <tt><b>return</b></tt> UESURI of the property collection template
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.setCollectionAttributes(collTemplateUri, propertyCollTemplate = nil)
    collTemplateUri = Ues::Core::Commons::Uri::UESURI.new(collTemplateUri).to_java
    propertyCollTemplate = Ues::Core::Property::UESPropertyTemplateSetCollectionAttributes.new(propertyCollTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.setCollectionAttributes(collTemplateUri, propertyCollTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias set_collection_attributes setCollectionAttributes
  end

# Sets a new value on the specified property template. The data type of the value must match the data type of the specified property
# template.
# 
# <tt><b>param</b></tt> propertyTemplateUri UESURI of the property template
# 
# <tt><b>param</b></tt> value the new value of the property template
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.setValue(propertyTemplateUri, value = nil)
    propertyTemplateUri = Ues::Core::Commons::Uri::UESURI.new(propertyTemplateUri).to_java
    value = Ues::Core::Property::UESPropertyTemplate.send("convert_to_java", value)
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.setValue(propertyTemplateUri, value)
    
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias set_value setValue
  end

# Moves a property template to the new location (see UESPropertyTemplateMove#parentNodeUri) on the same artifact. New
# location can be property template collection or Meta Artifact.
# 
# <tt><b>param</b></tt> propertyTemplateUri UESURI of the property template to be moved
# 
# <tt><b>param</b></tt> newLocation Object containing the new location of the property template
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
# 
# <tt><b>since</b></tt> UES8-06
  def self.move(propertyTemplateUri, newLocation = nil)
    propertyTemplateUri = Ues::Core::Commons::Uri::UESURI.new(propertyTemplateUri).to_java
    newLocation = Ues::Core::Property::UESPropertyTemplateMove.new(newLocation).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.move(propertyTemplateUri, newLocation)
    
    return _r
  end

# Moves a property template collection to the new location (see UESPropertyTemplateMoveCollection#parentNodeUri) on the same Meta Artifact. This template collection can not be base template
# collection. New location can be property template collection or Meta Artifact, and it can not be child of or the same as property
# template collection which is about to be moved.
# 
# <tt><b>param</b></tt> collectionUri UESURI of the property template collection which is about to be moved
# 
# <tt><b>param</b></tt> newLocation Object containing the new location of the property template collection
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
# 
# <tt><b>since</b></tt> UES8-06
  def self.moveCollection(collectionUri, newLocation = nil)
    collectionUri = Ues::Core::Commons::Uri::UESURI.new(collectionUri).to_java
    newLocation = Ues::Core::Property::UESPropertyTemplateMoveCollection.new(newLocation).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.moveCollection(collectionUri, newLocation)
    
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias move_collection moveCollection
  end

# Deletes the property template from the system.
# 
# <tt><b>param</b></tt> propertyTemplateUri UESURI of the property template which is about to be deleted
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.delete(propertyTemplateUri)
    propertyTemplateUri = Ues::Core::Commons::Uri::UESURI.new(propertyTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.delete(propertyTemplateUri)
    
    return _r
  end

# Deletes the specified property collection template. When recursive is set in options, all nested objects in property collection
# template are also removed.
# 
# <tt><b>param</b></tt> collTemplateUri UESURI of the property collection template which is about to be deleted
# 
# <tt><b>param</b></tt> options Object containing options for deletion
# 
# <tt><b>throws</b></tt> UESPropertyTemplateRTException
  def self.deleteCollection(collTemplateUri, options = nil)
    collTemplateUri = Ues::Core::Commons::Uri::UESURI.new(collTemplateUri).to_java
    options = Ues::Core::Property::UESPropertyTemplateDeleteCollection.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESPropertyTemplate.java_class)
    _r = _s.deleteCollection(collTemplateUri, options)
    
    return _r
  end
  class << Ues::Core::Property::UESPropertyTemplate
    alias delete_collection deleteCollection
  end

  def self.convert_to_java(value) #:nodoc:
    if (value.java_kind_of?File)
      if (value.java_kind_of?File) then value = Java::java.io.File.new(value.path) end
    elsif (value.java_kind_of?Array)
      if (value != nil) then _t = []; value.to_a.each do |_e|; _e = convert_to_java(_e); _t << _e; end; value = Java::java.util.ArrayList.new(_t); end;
    elsif ((value.java_kind_of?Fixnum) || (value.java_kind_of?Float) || (value.java_kind_of?Bignum))
      if ((value.java_kind_of?Fixnum) || (value.java_kind_of?Float) || (value.java_kind_of?Bignum)) then value.to_java end
    elsif (value.java_kind_of?Exception)
      if (value.java_kind_of?NativeException) then value = value.cause elsif (value.java_kind_of?Exception) then; _t = []; begin value.backtrace.each do |_e|; _p = _e.split(":"); _t.push(Java::java.lang.StackTraceElement.new(_p[0], "", _p[2], Integer(_p[1]))); end; rescue; end; value = Java::java.lang.Exception.new(value.message); value.setStackTrace(_t.to_java(Java::java.lang.StackTraceElement)); end;
    else
      if ((!value.java_kind_of?Java::java.lang.Object) && (value.class.method_defined?"to_java")) then value = value.to_java end
    end
    return value
  end
  private_class_method :convert_to_java

  def self.convert_to_ruby(value) #:nodoc:
  	if (value == nil)
  	  return value
  	elsif (value.java_kind_of?Java::java.util.Date)
  	  if (value != nil) then value = Time.at(value.getTime/1000) end
    elsif (value.java_kind_of?Java::javax.xml.datatype.XMLGregorianCalendar)
      if (value != nil) then value = Time.at(value.toGregorianCalendar.getTimeInMillis/1000) end
    elsif (value.java_kind_of?Java::java.io.InputStream)
      if (value != nil) then value = Java.java_to_ruby(org.jruby.RubyIO.new(JRuby.runtime, value).java_object) end
    elsif (value.java_kind_of?Java::java.io.OutputStream)
      if (value != nil) then value = Java.java_to_ruby(org.jruby.RubyIO.new(JRuby.runtime, value).java_object) end
    elsif (value.java_kind_of?Java::java.io.File)
      if (value != nil) then if (File.exist?value.getPath) then value = File.new(value.getPath, "r") else value = File.new(value.getPath, "a") end end
    elsif (value.java_kind_of?Java::java.util.Collection)
      _t = [];value.to_a.each do |_e|; _e = convert_to_ruby(_e); _t << _e; end; value = _t;
    elsif (value.java_kind_of?Java::java.util.Iterator)
      _t = []; value.to_a.each do |_e|; _e = convert_to_ruby(_e); _t << _e; end; value = _t.each;
    else
      dto = dto_class(value); if (dto != nil) then if (value != nil) then value = dto.new(value) end; end;
    end
    return value
  end
  private_class_method :convert_to_ruby
  
  def self.dto_class(value) #:nodoc:
    name = value.class.to_s
    if (name.start_with?("Java"))
      _t = name.gsub(/[A-Z]/) {|c| ' ' + c}.split(" ")
      if (_t.size < 5)
        return nil
      end
      name = _t[2] + "::" + _t[3] + "::" + _t[4] + "::" + name[name.rindex(":") + 1, name.length]
      begin
        return Module.class_eval(name)
      rescue NameError
        return nil
      end
    elsif ((name.start_with?("#")) || (name["Ues::"] == nil))
      return nil
    else
      return value.class
    end
  end
  private_class_method :dto_class

end
